;*****************************************************************
;* Controller Tiny2313 20 Mhz
;* RGB Dimmung Plus Master
;*****************************************************************




;*****************************************************************
;*** Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl ***********


;*** Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl ***********
;*****************************************************************
.equ	cpu_x=0;CPU: Tiny2313 = 0  Tiny2313A = 1 
;*** Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl Wahl ***********
;*****************************************************************
;*** Fuses *******************************************************
;X Brown out detect level at VCC=4.3 (bodlevel=100)
;X Reset Disabled  (RSTDISBL=0)
;X fr Master Ext.Crystal Osc 8.0- MHz
;   start-up-time 14CK + 65ms(CKSEL=1111 SUT=11)
;* fuses     0xff,0xf8,0xff 
;X fr Slave Ext.Crystal Osc 8.0- MHz
;   start-up-time 14CK + 65ms(CKSEL=1111 SUT=11)
;* fuses     0xff,0xf8,0xff 
;*** LockBits wenn lust
;X Mode 3
;* lockbits  0xfc




;*** PIN-belegung ***
;*1  reset /hi=tiny 1 lo=tiny 2
;*2  PD0 DMX/RS232 IN  <-
;*3  PD1 DMX/RS232 OUT ->
;*4  XTAL 20MHz|1KOhm->UB +5V
;*5  XTAL 20MHZ|zweiten Controller	
;*6  PD2 INT0 LED B
;*7  PD3 INT1  
;*8  PD4      LED G 
;*9  PD5      LED R 
;*10 GND

;*11 PD6 out RX/TX ->SN75176 (RE,DE)
;*12 PB0 
;*13 PB1
;*14 PB2
;*15 PB3  
;*16 PB4  
;*17 PB5 
;*18 PB6
;*19 PB7
;*20 UB +5V  




;************************************************************
.if cpu_x == 0
.include "tn2313def.inc"
.endif
.if cpu_x == 1
.include "tn2313adef.inc"
.endif

;.include "..\ich_tool\avr_plus_temp.inc";maros
.include "avr_plus_temp.inc";maros


;************************************************************
;* EQUs *****************************************************

;*** RDM ***
;*** set_UID_adr:;6 Bytes
.equ set_UID_0_adr = 0xD9;msb
.equ set_UID_1_adr = 0x03
.equ set_UID_2_adr = 0x00
.equ set_UID_3_adr = 0x00
.equ set_UID_4_adr = 0x00
.equ set_UID_5_adr = 0x00;lsb

.equ RDM_response_delay=44 ;bei 20 MHz
.equ RDM_Befehls_ID_max=0  ;0=RDMmini 1=RDMmax	
.equ RDM_auswertung_Bf_equ=0 ;0=bf_equ 1=lo_bf_equ
.equ RDM_cpu_select=1 ;0=Mega88 1=Tiny2313
.equ DMX_footprint=4
;*** RX/TX ->SN75176 (RE,DE)
.equ port_RE_DE = portD
.equ pin_RE_DE = 6


.dseg;*******************************************************
.org 0x60
DMX_puffer:
dmx_in_ram:		;DMX-begin 
dmx_in_ram_0:	.byte 1	;DMX/RS232 input 1
dmx_in_ram_1:	.byte 1	;DMX/RS232 input 2
dmx_in_ram_2:	.byte 1	;DMX/RS232 input 3
dmx_in_master:	.byte 1 ;Master-kanal
dmx_in_ram_end:	;DMX-in-end 
dmx_out_ram:
dmx_out_ram_0:	.byte 1
dmx_out_ram_1:	.byte 1
dmx_out_ram_2:	.byte 1
dmx_out_master: .byte 1
dmx_out_ram_end:

;****** sram max 0xe0 ********************************************



.eseg;************************************************************
.org 0
ee_dumi_0:	.db 0x55
ee_dumi_1:	.db 0xAA


;*** REGISTER ****************************************************
.def	prog_data	=R0	;werte fr prog-data,MUL LO	
.def	MUL_HI		=R1     ;MUL HI 
.def	S		=R2	;int speicher
.def    mul_timer	=R3	
;
.def    LED_R 	        =R7	
.def	LED_G		=R8
.def	LED_B		=R9
;.def	LED_W		=R10




.def	da_count	=R12
.def	phase_count	=R13
.def    c_time0	  	=R14	
;.def    timer_lo	=R15	




.def bf_equ		= R16
			;0=DMX/RS in 8->16bit ->korektur
			;1=new 16bit e-soft fr Phase
			;2=LEDout + KEYscan
			;3=KEYauswertung/Debug Hex auf LED out
			;4=
			;5=
			;6=
			;7=

			 ;0=new AD-in	;
.def status		= R17
			 ;0=	
			 ;1=	
			 ;2=	
			 ;3=	
			 ;4=	
			 ;5=ad-anders	
			 ;6=flash 0=LED off 1=LED on	
			 ;7=flash 0=off 1=on


;*****************************************************************
.cseg
.org 0
	rjmp RESET    ; Reset Handler
	reti          ; External Interrupt0 Handler
	reti	      ; External Interrupt1 Handler
	reti	      ; Timer1 Capture Handler
	reti	      ; Timer1 CompareA Handler
	reti;rjmp TIM1_OVF ; Timer1 Overflow Handler
	rjmp TIM0_OVF ; Timer0 Overflow Handler
	rjmp RDM_USART_RXC ; USART0 RX Complete Handler
	reti;rjmp UART0_DRE ; USART0,UDR Empty Handler
	rjmp RDM_USART_TXC ; USART0 TX Complete Handler
	reti;rjmp ANA_COMP ; Analog Comparator Handler
	reti;rjmp PCINT ; Pin Change Interrupt
	reti;rjmp TIMER1_COMPB ; Timer1 Compare B Handler
	reti;rjmp TIMER0_COMPA ; Timer0 Compare A Handler
	reti;rjmp TIMER0_COMPB ; Timer0 Compare B Handler
	reti;rjmp USI_START ; Usi Start Handler
	reti;rjmp USI_OVERFLOW ; USI Overflow Handler
	reti;rjmp EE_READY ; EEPROM Ready Handler
	reti;rjmp WDT_OVERFLOW ; Watchdog Overflow Handler


;*****************************************************************
;*** include *********************************************
;.include "..\ich_tool\eeprom_2313_RW.inc";R/W EEPROM
;.include "..\ich_tool\DMX_RDM.asm";DMX-RDM
.include "eeprom_2313_RW.inc";R/W EEPROM
.include "DMX_RDM.asm";DMX-RDM




;*****************************************************************
TIM0_OVF:
        in      S,sreg
	push	temp0

	;*** time0 count-korrektur auf 20s
	in	temp0,tcnt0	;hole time 0
	add	temp0,c_time0	;add time neu
        out     tcnt0,temp0   	;zurck in timer

	;*** time0 * x
        inc     mul_timer
	;*** reset DA
	tst	da_count
	brne	t0_da_dim

	inc	phase_count

	mov	temp0,phase_count
	andi	temp0,1+2+4
	brne	t0_no_bf_equ
	sbr	bf_equ,2
t0_no_bf_equ:

        cbi     portd,2  ;R-LED              
        cbi     portd,4  ;G-LED              
        cbi     portd,5  ;B-LED              
;        cbi     portd,3  ;W-LED              

	ldi	temp0,255
	mov	da_count,temp0

	;*** DA-DIM ************************************************
t0_da_dim:;*** Leistungs korrektur ini *****************************
; (256-147)*20+((256-50)-(256-146))*40+((256-10)-(256-51))*20+11*160+70*20
	mov	temp0,da_count

	cpi	temp0,256-16;*** slow ***
	brsh	da_x_mul16	
	cpi	temp0,256-32;*** slow ***
	brsh	da_x_mul8	
	cpi	temp0,256-64;*** slow ***
	brsh	da_x_mul4	
	cpi	temp0,256-128;*** slow ***
	brsh	da_x_mul2	
	rjmp	da_start
	;*** Leistungs korrektur ***********************************
da_x_mul16:
        sbrs    mul_timer,3     ; time*16
	rjmp	time_weiter
da_x_mul8:
        sbrs    mul_timer,2     ; time*8
	rjmp	time_weiter
da_x_mul4:
        sbrs    mul_timer,1     ; time*4
	rjmp	time_weiter
da_x_mul2:
        sbrs    mul_timer,0     ; time*2
        rjmp    time_weiter
	rjmp	da_start
da_start:;*** DIM DA START *****************************************
        cp      LED_R,da_count
        brlo    da_0
        sbi     portd,2                
da_0:
        cp      LED_G,da_count
        brlo    da_1
        sbi     portd,4                
da_1:
        cp      LED_B,da_count
        brlo    da_2
        sbi     portd,5                
da_2:
;        cp      LED_W,da_count
;        brlo    da_3
;        sbi     portd,3                
da_3:
da_end:;*** DA-DIM end
        dec     da_count
time_weiter:

	;*** RDM-Delay_timer
	lds	temp0,RDM_timer_delay
	tst	temp0
	breq	tim0_no_RDM_timer_delay
	dec	temp0
	sts	RDM_timer_delay,temp0
	brne	tim0_no_RDM_timer_delay
	;* set funktion -> TX-out in 176s (14=179.2s)
	sbr	bf_equ,32;TX-out
tim0_no_RDM_timer_delay:

	pop	temp0
        out     sreg,S
        reti
;********************************************************************
;USART_RXC: 	;USART, RX Complete Handler
;********************************************************************
;UART_DRE:	reti		      ; UDR Empty Handler
;********************************************************************
;USART_TXC:                  ; UART TX Complete Handler
;********************************************************************
;ANA_COMP:	reti                  ; Analog Comparator Handler
;********************************************************************

reset:
	ldi  	temp0,low(RAMEND) ;Initialize stackpointer
	out	SPL,temp0		

;*** Test ***********************
;	ldi	temp0,255
;	ldi	temp1,255
;	rcall	mul_call_sp
;	nop
;*** END Test *******************
	;*** watch dog on
        wdr                     ;watchdog reset
	ldi	temp1,1+2+4+8	;Watchdog on  0.97s
	out	wdtcsr,temp1
	;*** REGs ini alle auf null
	clr	zh
	clr	yh
	clr	xh
	clr	temp0		;temp0=0
	ldi	zl,0x00		;REGs ini
res_regs:
	st	z+,temp0
	cpi	zl,30
	brlo	res_regs
	;*** RAM ini alle auf null
	ldi	zl,0x60		;SRAM ini
res_sram:
	st	z+,temp0
	cpi	zl,0x60+128
	brlo	res_sram
	;*** INT-inputs ini
;	ldi	temp1,64;+128	;int0 on
;	out	gimsk,temp1

;	ldi	temp1,2;+8	;fallend  ->LO ->int0
;	out	mcucr,temp1
	;* timer 0/1 ini
	ldi	temp1,1		;Timer/Counter 0 clocked at CK
	out	TCCR0,temp1
        ldi     temp1,2;+32+64+128 ;Enable Timer0 overflow interrupt
	out	TIMSK,temp1

	;* portA  
;	ldi	temp0,0
;	out	porta,temp0	;temp0=0
;       ldi     temp1,4		 ;portA bit 2 as output
;       out     ddrA,temp1
	;* portB
	ldi	temp1,0	;PORTB bit 1,2 (on)
        out	portb,temp1
	ldi	temp1,1+2+4+8+16+32+64+128;PORTB bit 0,1,2,3,5,6,7 as output
	out	DDRB,temp1
	;* portD
	ldi	temp1,0;PortD bit 0,1,2,3,4,5 (on)
	out	portd,temp1
        ldi     temp1,4+8+16+32+64 	;portD als output bit 4,6
        out     ddrd,temp1
	;*** Serial ini
	ldi	temp0,0
	ldi     temp1,8+16+64+128  ;ini uard RX/TX on
	out	ucsrB,temp1
;	out	UCSRA,temp0	;temp0=0
	ldi     temp1,2+4+8   	;8 bit data 2 stopbit noparity
	out	UCSRC,temp1
	out	ubrrh,temp0	;temp0=0
        ldi     temp1,4 	;baundrate 250kbit by 20MHz
	out	ubrrl,temp1
;	in	temp1,udr
	;*DMX - RDM
	;* DMX adr
	rcall	DMX_RDM_INI

	ldi	temp1,180
	mov	c_time0,temp1
	;* start int

	sei

;*** TEST ****************************
;	rcall	RDM_test_array
;	rcall   RDM_auswertung
;	nop
;*** TEST ****************************

;*****************************************************************
main:
	;*** var Prfung ***
	in	temp0,SPL	;stack Prfung
	cpi	temp0,low(RAMEND)
	breq	ok_weiter					
warte_reset:;*** warte auf reset
	rjmp	warte_reset
ok_weiter:
        wdr 

	;*** BEF.XX **********************************************
bf_equ_w0:;*** 0  1 Befehl EQU ***
	;*** DMX/RS RXin ***
	sbrs	bf_equ,0
	rjmp	bf_equ_w1
	cbr	bf_equ,1

	lds	temp0,dmx_in_ram_0
	lds	temp1,dmx_in_master
	rcall	mul_call_tst
	sts	dmx_out_ram_0,temp3

	lds	temp0,dmx_in_ram_1
	lds	temp1,dmx_in_master
	rcall	mul_call_tst
	sts	dmx_out_ram_1,temp3

	lds	temp0,dmx_in_ram_2
	lds	temp1,dmx_in_master
	rcall	mul_call_tst
	sts	dmx_out_ram_2,temp3

;	lds	temp0,dmx_in_ram_3
;	lds	temp1,dmx_in_master
;	rcall	mul_call_tst
;	sts	dmx_out_ram_3,temp3


	;* end DMX/Rs IN
	rjmp	main
bf_equ_w1:;*** 1  2 Befehl EQU ***
	;*** DMX/RS RXin ***
	sbrs	bf_equ,1
	rjmp	bf_equ_w2
	cbr	bf_equ,2

	lds	temp1,dmx_out_ram_0
	mov	temp2,LED_R;in -> old_dim_wert=temp2
	rcall	e_soft
	mov	LED_R,temp3

	lds	temp1,dmx_out_ram_1
	mov	temp2,LED_G;in -> old_dim_wert=temp2
	rcall	e_soft
	mov	LED_G,temp3

	lds	temp1,dmx_out_ram_2
	mov	temp2,LED_B;in -> old_dim_wert=temp2
	rcall	e_soft
	mov	LED_B,temp3

;	lds	temp1,dmx_out_ram_3
;	mov	temp2,LED_B;in -> old_dim_wert=temp2
;	rcall	e_soft
;	mov	LED_W,temp3


;	sbrc	timer_lo,1
;	rjmp	bf_equ_w1_DMX_timeout
	;*** DMX timeout
	lds	temp0,dmx_time_out
	inc	temp0;dmx_time_out
	sts	dmx_time_out,temp0
	brne	bf_equ_w1_no_DMX_time_out

	lds	temp0,DMX_RDM_status
	sbr	temp0,1;Bit 0  time_out_dmx
	sts	DMX_RDM_status,temp0
bf_equ_w1_no_DMX_time_out:
bf_equ_w1_DMX_timeout:


	rjmp	main
bf_equ_w2:
	sbrs	bf_equ,2
	rjmp	bf_equ_w3
	cbr	bf_equ,4
	rjmp	main
bf_equ_w3:
	sbrs	bf_equ,3
	rjmp	bf_equ_w4
	cbr	bf_equ,8
	rjmp	main
bf_equ_w4:
	sbrs	bf_equ,4
	rjmp	bf_equ_w5
	cbr	bf_equ,16
	;*** RDM-auswertung ***
	rcall   RDM_auswertung

	rjmp	main
bf_equ_w5:
	sbrs	bf_equ,5
	rjmp	bf_equ_w6
	cbr	bf_equ,32
	;*** RDM-TX-out ***
	
	rcall	RDM_response_TX

	rjmp	main
bf_equ_w6:
	sbrs	bf_equ,6
	rjmp	bf_equ_w7
	cbr	bf_equ,64

	rjmp	main
bf_equ_w7:
	sbrs	bf_equ,7
	rjmp	bf_equ_end
	cbr	bf_equ,128

	rjmp	main

bf_equ_end:


	rjmp	main
;*****************************************************************
;*****************************************************************

;*** mul 8*8=16 Bit in temp0*temp1=temp2/3
mul_call_tst:
	tst	temp0
	brne	mul_call_sp
	tst	temp1
	brne	mul_call_sp
	ldi	temp3,0
	ret
mul_call_sp:;* mul 8*8+255=16 Bit
	ser	temp3		;set 255 result High byte
	rjmp	mul_call_w1	
mul_call:;* mul 8*8=16 Bit
	clr	temp3		;clear result High byte
	clr	temp2		;clear result High byte
mul_call_w1:
	ldi	temp4,8		;init loop counter
	push	temp4
m8u_1:
	lsr	temp1		;rotate multiplier
	brcc	m8u_2		;carry set 
	add 	temp3,temp0	;add multiplicand to result High byte
m8u_2:	ror	temp3		;rotate right result High byte
	ror	temp2		;rotate right result L byte and multiplier
	dec	temp4		;decrement loop counter
	brne	m8u_1		;if not done, loop more
	pop	temp4
	ret

mul_call_st:
	com	temp2		;invert LO
	com	temp3		;invert HI
	st	z+,temp2
	st	z+,temp3
	ret

;*****************************************************
;*** e_soft
;in -> new_dim_wert=temp1
;in -> old_dim_wert=temp2
;rcall	e_soft
;out <-    dim_wert=temp3
e_soft:
	mov	temp3,temp2	;dim_ram in temp3 sichern
	sub	temp2,temp1	;differenz ???
	breq	e_soft_w1
	mov	temp4,phase_count
	ldi	temp1,3;10;16	;grenz-wert 
	brcc	e_soft_klein	
	add	temp1,temp2
	brcc	e_soft_w4	;testen ob kleiner 10
	and	temp4,temp1	
	brne	e_soft_w1	;diese phase nicht
e_soft_w4:
	swap	temp2		;wert der Vergrerung von dim_ram
	ori	temp2,128+64+32+16;bit fr -Wert setzen (-sub=add)
	rjmp	e_soft_w2
e_soft_klein:
	sub	temp1,temp2
	brcs	e_soft_w3	;testen ob kleiner 10
	and	temp4,temp1
	brne	e_soft_w1	;diese phase nicht
e_soft_w3:
	swap	temp2		;wert der Verkeinerung von dim_ram
	andi	temp2,1+2+4+8	;16+32+64+128 lschen
	inc	temp2
e_soft_w2:
	sub	temp3,temp2	;neuer wert
e_soft_w1:
	ret

;*******************************************************





















